# buildforkernels macro hint: when you build a new version or a new release
# that contains bugfixes or other improvements then you must disable the
# "buildforkernels newest" macro for just that build; immediately after
# queuing that build enable the macro again for subsequent builds; that way
# a new akmod package will only get build when a new one is actually needed
#%%define buildforkernels newest

Name:		tp_smapi-kmod
Version:	0.43
Release:	2%{?dist}
Summary:	Kernel module for some Thinkpad hardware/firmware features

%define distname tp_smapi-%{version}

Group:		System Environment/Kernel
License:	GPL
URL:		http://www.thinkwiki.org/wiki/Tp_smapi
Source0:        https://github.com/evgeni/tp_smapi/releases/download/tp-smapi/%{version}/tp_smapi-%{version}.tgz
#Patch0:         %{distname}-declare-mutex.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	%{_bindir}/kmodtool
BuildRequires:	gcc
BuildRequires:	elfutils-libelf-devel

# needed for plague to make sure it builds for i586 and i686
ExclusiveArch:  i586 i686 x86_64

%{!?kernels:BuildRequires: buildsys-build-rpmfusion-kerneldevpkgs-%{?buildforkernels:%{buildforkernels}}%{!?buildforkernels:current}-%{_target_cpu} }

# kmodtool does its magic here
%{expand:%(kmodtool --target %{_target_cpu} --repo rpmfusion --kmodname %{name} %{?buildforkernels:--%{buildforkernels}} %{?kernels:--for-kernels "%{?kernels}"} 2>/dev/null) }

%description
The tp_smapi kernel module exposes some features of the ThinkPad
hardware/firmware via a sysfs interface. Currently, the main implemented
functionality is control of battery charging and extended battery
status. The underlying hardware interfaces are SMAPI and direct access
to the embedded controller.

%prep
%{?kmodtool_check}

# print kmodtool output for debugging purposes:
kmodtool --target %{_target_cpu}  --repo rpmfusion --kmodname %{name} %{?buildforkernels:--%{buildforkernels}} %{?kernels:--for-kernels "%{?kernels}"} 2>/dev/null

%setup -q -c -T -a 0
#pushd %{distname}
#%patch0 -p1 -b .%{distname}-declare-mutex
#popd

# Fix permissions
for ext in c h; do
  find . -name "*.$ext" -exec chmod -x '{}' \;
done

for kernel_version in %{?kernel_versions} ; do
  cp -a %{distname} _kmod_build_${kernel_version%%___*}
done

%build
for kernel_version in %{?kernel_versions}; do
  %{__make} %{_smp_mflags} -C _kmod_build_${kernel_version%%___*} KVER="${kernel_version%%___*}" KBUILD="${kernel_version##*___}" HDAPS=1
done

%install
rm -rf ${RPM_BUILD_ROOT}
for kernel_version in %{?kernel_versions}; do
  mkdir -p $RPM_BUILD_ROOT%{kmodinstdir_prefix}/${kernel_version%%___*}/%{kmodinstdir_postfix}
  pushd _kmod_build_${kernel_version%%___*}
  install -D -m 0755 *.ko $RPM_BUILD_ROOT%{kmodinstdir_prefix}/${kernel_version%%___*}/%{kmodinstdir_postfix}
  popd
done

%{?akmod_install}

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Dec 04 2018 josef radinger <cheese@nosuchhost.net> - 0.43-2
- add BuildRequires onto gcc
- add BuildRequires onto elfutils-libelf-devel

* Thu Mar 01 2018 josef radinger <cheese@nosuchhost.net> - 0.43-1
- bump version

* Tue Jul 12 2016 josef radinger <cheese@nosuchhost.net> - 0.42-1
- bump version

* Tue Apr 17 2012 josef radinger <cheese@nosuchhost.net> - 0.41-1
- bump version (fork on github!!!)
- fix typo

* Mon Nov 21 2011 Matthias Haase <matthias_haase@bennewitz.com> - 0.40-6
- Rebuild for Fedora 16

* Sat May 28 2011 Matthias Haase <matthias_haase@bennewitz.com> - 0.40-5
- Rebuild for Fedora 15

* Mon Jan 17 2011 Matthias Haase <matthias_haase@bennewitz.com> - 0.40-4
- pushd / popd used instead of cd / cd.. on %setup

* Mon Jan 17 2011 Matthias Haase <matthias_haase@bennewitz.com> - 0.40-3
- some clean up done
- %{__make} %{_smp_mflags} is used now instead of make

* Sun Jan 16 2011 Matthias Haase <matthias_haase@bennewitz.com> - 0.40-2
- declare-mutex.patch added to build against kernel >=  2.6.37

* Sun Apr 05 2009 Fabrice Bellet <fabrice@bellet.info> 0.40-1
- Initial package for Fedora
